// C.Dupaty 09-2011
// exemple de gestion des communications sries asynchrones
// Fosc=32MHz (interne), comm : 9600,n,8,1
// PROGRAMME : echo.c

#include <p18f4620.h>

rom char mess[]="\nLes communications sont ouvertes\n\rTapez une touche ...\n\n";
// indique qu'un caractre est dans RCREG de l'USART 

char data_recue(void)			
{	
	if (PIR1bits.RCIF)		/* char recu en reception*/
	{	
		PIR1bits.RCIF=0;	// efface drapeau
		return (1);			// indique qu'un nouveau caractre est dans RCREG
	}	
	else return (0);		// pas de nouveau caractre reu
}

// envoie un caractre sur USART
void putch(unsigned char c) 		//putch est dfini sur le port srie
{   
	while(!TXSTAbits.TRMT);			// pas de transmission en cours ?
    TXREG=c;                         /* envoie un caractre */
    while(!PIR1bits.TXIF);
}

// envoie une chaine en ROM
void putchaine(rom char* chaine)
{	
	while (*chaine) putch(*chaine++);
}

void main(void)
{
	init_horloge_interne();
	TXSTA = 0b00100000; 	                  
	RCSTA = 0b10010000;	
	PIE1bits.TXIE=0;	// IT en emission dsactive
	PIE1bits.RCIE=0;	// IT en reception dactive 
	BAUDCONbits.BRG16=0;	
	TXSTAbits.BRGH=0;		
	SPBRG = 51;
    putchaine(mess);	// intro
   	while(1)		// echo +1 ex: si a est transmis b est envoy en echo
	    {
			 if (data_recue()) putch(RCREG+1); 
		}
}
